diff --git a/meson.build b/meson.build
index d7c5193d4ce..4972c7b26d4 100644
--- a/meson.build
+++ b/meson.build
@@ -2626,145 +2664,145 @@ endif
 # XXX: Might be worth conditioning some checks on the OS, to avoid doing
 # unnecessary checks over and over, particularly on windows.
 header_checks = [
-  'atomic.h',
-  'copyfile.h',
-  'crtdefs.h',
-  'execinfo.h',
-  'getopt.h',
-  'ifaddrs.h',
-  'mbarrier.h',
-  'strings.h',
-  'sys/epoll.h',
-  'sys/event.h',
-  'sys/personality.h',
-  'sys/prctl.h',
-  'sys/procctl.h',
-  'sys/signalfd.h',
-  'sys/ucred.h',
-  'termios.h',
-  'uchar.h',
-  'ucred.h',
-  'xlocale.h',
+	'atomic.h',
+	'copyfile.h',
+	'crtdefs.h',
+	'execinfo.h',
+	'getopt.h',
+	'ifaddrs.h',
+	'mbarrier.h',
+	'strings.h',
+	'sys/epoll.h',
+	'sys/event.h',
+	'sys/personality.h',
+	'sys/prctl.h',
+	'sys/procctl.h',
+	'sys/signalfd.h',
+	'sys/ucred.h',
+	'termios.h',
+	'uchar.h',
+	'ucred.h',
+	'xlocale.h',
 ]
 
 foreach header : header_checks
-  varname = 'HAVE_' + header.underscorify().to_upper()
+	varname = 'HAVE_' + header.underscorify().to_upper()
 
-  # Emulate autoconf behaviour of not-found->undef, found->1
-  found = cc.has_header(header,
-    include_directories: postgres_inc, args: test_c_args)
-  cdata.set(varname, found ? 1 : false,
-            description: 'Define to 1 if you have the <@0@> header file.'.format(header))
+	# Emulate autoconf behaviour of not-found->undef, found->1
+	found = cc.has_header(header,
+		include_directories: postgres_inc, args: test_c_args)
+	cdata.set(varname, found ? 1 : false,
+						description: 'Define to 1 if you have the <@0@> header file.'.format(header))
 endforeach
 
 
 decl_checks = [
-  ['F_FULLFSYNC', 'fcntl.h'],
-  ['fdatasync', 'unistd.h'],
-  ['posix_fadvise', 'fcntl.h'],
-  ['strlcat', 'string.h'],
-  ['strlcpy', 'string.h'],
-  ['strnlen', 'string.h'],
-  ['strsep',  'string.h'],
-  ['timingsafe_bcmp',  'string.h'],
+	['F_FULLFSYNC', 'fcntl.h'],
+	['fdatasync', 'unistd.h'],
+	['posix_fadvise', 'fcntl.h'],
+	['strlcat', 'string.h'],
+	['strlcpy', 'string.h'],
+	['strnlen', 'string.h'],
+	['strsep',  'string.h'],
+	['timingsafe_bcmp',  'string.h'],
 ]
 
 # Need to check for function declarations for these functions, because
 # checking for library symbols wouldn't handle deployment target
 # restrictions on macOS
 decl_checks += [
-  ['preadv', 'sys/uio.h'],
-  ['pwritev', 'sys/uio.h'],
-  ['strchrnul', 'string.h'],
-  ['memset_s', 'string.h', '#define __STDC_WANT_LIB_EXT1__ 1'],
+	['preadv', 'sys/uio.h'],
+	['pwritev', 'sys/uio.h'],
+	['strchrnul', 'string.h'],
+	['memset_s', 'string.h', '#define __STDC_WANT_LIB_EXT1__ 1'],
 ]
 
 # Check presence of some optional LLVM functions.
 if llvm.found()
-  decl_checks += [
-    ['LLVMCreateGDBRegistrationListener', 'llvm-c/ExecutionEngine.h'],
-    ['LLVMCreatePerfJITEventListener', 'llvm-c/ExecutionEngine.h'],
-  ]
+	decl_checks += [
+		['LLVMCreateGDBRegistrationListener', 'llvm-c/ExecutionEngine.h'],
+		['LLVMCreatePerfJITEventListener', 'llvm-c/ExecutionEngine.h'],
+	]
 endif
 
 foreach c : decl_checks
-  func = c.get(0)
-  header = c.get(1)
-  prologue = c.get(2, '')
-  args = c.get(3, {})
-  varname = 'HAVE_DECL_' + func.underscorify().to_upper()
+	func = c.get(0)
+	header = c.get(1)
+	prologue = c.get(2, '')
+	args = c.get(3, {})
+	varname = 'HAVE_DECL_' + func.underscorify().to_upper()
 
-  found = cc.compiles('''
+	found = cc.compiles('''
 @0@
 #include <@1@>
 
 int main()
 {
 #ifndef @2@
-    (void) @2@;
+		(void) @2@;
 #endif
 
 return 0;
 }
 '''.format(prologue, header, func),
-    name: 'test whether @0@ is declared'.format(func),
-    # need to add cflags_warn to get at least
-    # -Werror=unguarded-availability-new if applicable
-    args: test_c_args + cflags_warn,
-    include_directories: postgres_inc,
-    kwargs: args)
-  cdata.set10(varname, found, description:
+		name: 'test whether @0@ is declared'.format(func),
+		# need to add cflags_warn to get at least
+		# -Werror=unguarded-availability-new if applicable
+		args: test_c_args + cflags_warn,
+		include_directories: postgres_inc,
+		kwargs: args)
+	cdata.set10(varname, found, description:
 '''Define to 1 if you have the declaration of `@0@', and to 0 if you
-   don't.'''.format(func))
+	 don't.'''.format(func))
 endforeach
 
 
 if cc.has_type('struct option',
-    args: test_c_args, include_directories: postgres_inc,
-    prefix: '@0@'.format(cdata.get('HAVE_GETOPT_H')) == '1' ? '#include <getopt.h>' : '')
-  cdata.set('HAVE_STRUCT_OPTION', 1)
+		args: test_c_args, include_directories: postgres_inc,
+		prefix: '@0@'.format(cdata.get('HAVE_GETOPT_H')) == '1' ? '#include <getopt.h>' : '')
+	cdata.set('HAVE_STRUCT_OPTION', 1)
 endif
 
 
 foreach c : ['opterr', 'optreset']
-  varname = 'HAVE_INT_' + c.underscorify().to_upper()
+	varname = 'HAVE_INT_' + c.underscorify().to_upper()
 
-  if cc.links('''
+	if cc.links('''
 #include <unistd.h>
 int main(void)
 {
-    extern int @0@;
-    @0@ = 1;
+		extern int @0@;
+		@0@ = 1;
 }
 '''.format(c), name: c, args: test_c_args)
-    cdata.set(varname, 1)
-  else
-    cdata.set(varname, false)
-  endif
+		cdata.set(varname, 1)
+	else
+		cdata.set(varname, false)
+	endif
 endforeach
 
 if cc.has_type('socklen_t',
-    args: test_c_args, include_directories: postgres_inc,
-    prefix: '''
+		args: test_c_args, include_directories: postgres_inc,
+		prefix: '''
 #include <sys/socket.h>''')
-  cdata.set('HAVE_SOCKLEN_T', 1)
+	cdata.set('HAVE_SOCKLEN_T', 1)
 endif
 
 if cc.has_member('struct sockaddr', 'sa_len',
-    args: test_c_args, include_directories: postgres_inc,
-    prefix: '''
+		args: test_c_args, include_directories: postgres_inc,
+		prefix: '''
 #include <sys/types.h>
 #include <sys/socket.h>''')
-  cdata.set('HAVE_STRUCT_SOCKADDR_SA_LEN', 1)
+	cdata.set('HAVE_STRUCT_SOCKADDR_SA_LEN', 1)
 endif
 
 if cc.has_member('struct tm', 'tm_zone',
-    args: test_c_args, include_directories: postgres_inc,
-    prefix: '''
+		args: test_c_args, include_directories: postgres_inc,
+		prefix: '''
 #include <sys/types.h>
 #include <time.h>
 ''')
-  cdata.set('HAVE_STRUCT_TM_TM_ZONE', 1)
+	cdata.set('HAVE_STRUCT_TM_TM_ZONE', 1)
 endif
 
 if cc.compiles('''
@@ -2772,64 +2810,64 @@ if cc.compiles('''
 extern int foo(void);
 int foo(void)
 {
-    return timezone / 60;
+		return timezone / 60;
 }
 ''',
-    name: 'global variable `timezone\' exists',
-    args: test_c_args, include_directories: postgres_inc)
-  cdata.set('HAVE_INT_TIMEZONE', 1)
+		name: 'global variable `timezone\' exists',
+		args: test_c_args, include_directories: postgres_inc)
+	cdata.set('HAVE_INT_TIMEZONE', 1)
 else
-  cdata.set('HAVE_INT_TIMEZONE', false)
+	cdata.set('HAVE_INT_TIMEZONE', false)
 endif
 
 if cc.has_type('union semun',
-    args: test_c_args,
-    include_directories: postgres_inc,
-    prefix: '''
+		args: test_c_args,
+		include_directories: postgres_inc,
+		prefix: '''
 #include <sys/types.h>
 #include <sys/ipc.h>
 #include <sys/sem.h>
 ''')
-  cdata.set('HAVE_UNION_SEMUN', 1)
+	cdata.set('HAVE_UNION_SEMUN', 1)
 endif
 
 if cc.compiles('''
 #include <string.h>
 int main(void)
 {
-  char buf[100];
-  switch (strerror_r(1, buf, sizeof(buf)))
-  { case 0: break; default: break; }
+	char buf[100];
+	switch (strerror_r(1, buf, sizeof(buf)))
+	{ case 0: break; default: break; }
 }''',
-    name: 'strerror_r',
-    args: test_c_args, include_directories: postgres_inc)
-  cdata.set('STRERROR_R_INT', 1)
+		name: 'strerror_r',
+		args: test_c_args, include_directories: postgres_inc)
+	cdata.set('STRERROR_R_INT', 1)
 else
-  cdata.set('STRERROR_R_INT', false)
+	cdata.set('STRERROR_R_INT', false)
 endif
 
 # Check if the C compiler understands typeof or a variant.  Define
 # HAVE_TYPEOF if so, and define 'typeof' to the actual key word.
 foreach kw : ['typeof', '__typeof__']
-  if cc.compiles('''
+	if cc.compiles('''
 int main(void)
 {
-    int x = 0;
-    @0@(x) y;
-    y = x;
-    return y;
+		int x = 0;
+		@0@(x) y;
+		y = x;
+		return y;
 }
 '''.format(kw),
-    name: kw,
-    args: test_c_args, include_directories: postgres_inc)
+		name: kw,
+		args: test_c_args, include_directories: postgres_inc)
 
-    cdata.set('HAVE_TYPEOF', 1)
-    if kw != 'typeof'
-      cdata.set('typeof', kw)
-    endif
+		cdata.set('HAVE_TYPEOF', 1)
+		if kw != 'typeof'
+			cdata.set('typeof', kw)
+		endif
 
-    break
-  endif
+		break
+	endif
 endforeach
 
 
@@ -2869,115 +2907,115 @@ always_replace_getopt_long = host_system in ['windows', 'cygwin'] or not cdata.h
 execinfo_dep = cc.find_library('execinfo', required: false)
 
 if host_system == 'cygwin'
-  cygipc_dep = cc.find_library('cygipc', required: false)
+	cygipc_dep = cc.find_library('cygipc', required: false)
 else
-  cygipc_dep = not_found_dep
+	cygipc_dep = not_found_dep
 endif
 
 if host_system == 'sunos'
-  socket_dep = cc.find_library('socket', required: false)
+	socket_dep = cc.find_library('socket', required: false)
 else
-  socket_dep = not_found_dep
+	socket_dep = not_found_dep
 endif
 
 # XXX: Might be worth conditioning some checks on the OS, to avoid doing
 # unnecessary checks over and over, particularly on windows.
 func_checks = [
-  ['backtrace_symbols', {'dependencies': [execinfo_dep]}],
-  ['clock_gettime', {'dependencies': [rt_dep], 'define': false}],
-  ['copyfile'],
-  ['copy_file_range'],
-  # gcc/clang's sanitizer helper library provides dlopen but not dlsym, thus
-  # when enabling asan the dlopen check doesn't notice that -ldl is actually
-  # required. Just checking for dlsym() ought to suffice.
-  ['dlsym', {'dependencies': [dl_dep], 'define': false}],
-  ['elf_aux_info'],
-  ['explicit_bzero'],
-  ['getauxval'],
-  ['getifaddrs'],
-  ['getopt', {'dependencies': [getopt_dep, gnugetopt_dep], 'skip': always_replace_getopt}],
-  ['getopt_long', {'dependencies': [getopt_dep, gnugetopt_dep], 'skip': always_replace_getopt_long}],
-  ['getpeereid'],
-  ['getpeerucred'],
-  ['inet_aton'],
-  ['inet_pton'],
-  ['kqueue'],
-  ['localeconv_l'],
-  ['mbstowcs_l'],
-  ['mkdtemp'],
-  ['posix_fadvise'],
-  ['posix_fallocate'],
-  ['ppoll'],
-  ['pthread_barrier_wait', {'dependencies': [thread_dep]}],
-  ['pthread_is_threaded_np', {'dependencies': [thread_dep]}],
-  ['sem_init', {'dependencies': [rt_dep, thread_dep], 'skip': sema_kind != 'unnamed_posix', 'define': false}],
-  ['setproctitle', {'dependencies': [util_dep]}],
-  ['setproctitle_fast'],
-  ['shm_open', {'dependencies': [rt_dep], 'define': false}],
-  ['shm_unlink', {'dependencies': [rt_dep], 'define': false}],
-  ['shmget', {'dependencies': [cygipc_dep], 'define': false}],
-  ['socket', {'dependencies': [socket_dep], 'define': false}],
-  ['strerror_r', {'dependencies': [thread_dep]}],
-  ['strlcat'],
-  ['strlcpy'],
-  ['strnlen'],
-  ['strsep'],
-  ['strsignal'],
-  ['sync_file_range'],
-  ['syncfs'],
-  ['timingsafe_bcmp'],
-  ['uselocale'],
-  ['wcstombs_l'],
+	['backtrace_symbols', {'dependencies': [execinfo_dep]}],
+	['clock_gettime', {'dependencies': [rt_dep], 'define': false}],
+	['copyfile'],
+	['copy_file_range'],
+	# gcc/clang's sanitizer helper library provides dlopen but not dlsym, thus
+	# when enabling asan the dlopen check doesn't notice that -ldl is actually
+	# required. Just checking for dlsym() ought to suffice.
+	['dlsym', {'dependencies': [dl_dep], 'define': false}],
+	['elf_aux_info'],
+	['explicit_bzero'],
+	['getauxval'],
+	['getifaddrs'],
+	['getopt', {'dependencies': [getopt_dep, gnugetopt_dep], 'skip': always_replace_getopt}],
+	['getopt_long', {'dependencies': [getopt_dep, gnugetopt_dep], 'skip': always_replace_getopt_long}],
+	['getpeereid'],
+	['getpeerucred'],
+	['inet_aton'],
+	['inet_pton'],
+	['kqueue'],
+	['localeconv_l'],
+	['mbstowcs_l'],
+	['mkdtemp'],
+	['posix_fadvise'],
+	['posix_fallocate'],
+	['ppoll'],
+	['pthread_barrier_wait', {'dependencies': [thread_dep]}],
+	['pthread_is_threaded_np', {'dependencies': [thread_dep]}],
+	['sem_init', {'dependencies': [rt_dep, thread_dep], 'skip': sema_kind != 'unnamed_posix', 'define': false}],
+	['setproctitle', {'dependencies': [util_dep]}],
+	['setproctitle_fast'],
+	['shm_open', {'dependencies': [rt_dep], 'define': false}],
+	['shm_unlink', {'dependencies': [rt_dep], 'define': false}],
+	['shmget', {'dependencies': [cygipc_dep], 'define': false}],
+	['socket', {'dependencies': [socket_dep], 'define': false}],
+	['strerror_r', {'dependencies': [thread_dep]}],
+	['strlcat'],
+	['strlcpy'],
+	['strnlen'],
+	['strsep'],
+	['strsignal'],
+	['sync_file_range'],
+	['syncfs'],
+	['timingsafe_bcmp'],
+	['uselocale'],
+	['wcstombs_l'],
 ]
 
 func_check_results = {}
 foreach c : func_checks
-  func = c.get(0)
-  kwargs = c.get(1, {})
-  deps = kwargs.get('dependencies', [])
-
-  if kwargs.get('skip', false)
-    continue
-  endif
-
-  found = cc.has_function(func, args: test_c_args)
-
-  if not found
-    foreach dep : deps
-      if not dep.found()
-        continue
-      endif
-      found = cc.has_function(func, args: test_c_args,
-                              dependencies: [dep])
-      if found
-        os_deps += dep
-        break
-      endif
-    endforeach
-  endif
-
-  func_check_results += {func: found}
-
-  if kwargs.get('define', true)
-    # Emulate autoconf behaviour of not-found->undef, found->1
-    cdata.set('HAVE_' + func.underscorify().to_upper(),
-              found  ? 1 : false,
-              description: 'Define to 1 if you have the `@0@\' function.'.format(func))
-  endif
+	func = c.get(0)
+	kwargs = c.get(1, {})
+	deps = kwargs.get('dependencies', [])
+
+	if kwargs.get('skip', false)
+		continue
+	endif
+
+	found = cc.has_function(func, args: test_c_args)
+
+	if not found
+		foreach dep : deps
+			if not dep.found()
+				continue
+			endif
+			found = cc.has_function(func, args: test_c_args,
+															dependencies: [dep])
+			if found
+				os_deps += dep
+				break
+			endif
+		endforeach
+	endif
+
+	func_check_results += {func: found}
+
+	if kwargs.get('define', true)
+		# Emulate autoconf behaviour of not-found->undef, found->1
+		cdata.set('HAVE_' + func.underscorify().to_upper(),
+							found  ? 1 : false,
+							description: 'Define to 1 if you have the `@0@\' function.'.format(func))
+	endif
 endforeach
 
 
 if cc.has_function('syslog', args: test_c_args) and \
-    cc.check_header('syslog.h', args: test_c_args)
-  cdata.set('HAVE_SYSLOG', 1)
+		cc.check_header('syslog.h', args: test_c_args)
+	cdata.set('HAVE_SYSLOG', 1)
 endif
 
 
 # if prerequisites for unnamed posix semas aren't fulfilled, fall back to sysv
 # semaphores
 if sema_kind == 'unnamed_posix' and \
-   not func_check_results.get('sem_init', false)
-  sema_kind = 'sysv'
+	 not func_check_results.get('sem_init', false)
+	sema_kind = 'sysv'
 endif
 
 cdata.set('USE_@0@_SHARED_MEMORY'.format(shmem_kind.to_upper()), 1)
@@ -2989,10 +3027,10 @@ cdata.set_quoted('DLSUFFIX', dlsuffix)
 
 # built later than the rest of the version metadata, we need SIZEOF_VOID_P
 cdata.set_quoted('PG_VERSION_STR',
-  'PostgreSQL @0@ on @1@-@2@, compiled by @3@-@4@, @5@-bit'.format(
-    pg_version, host_machine.cpu_family(), host_system,
-    cc.get_id(), cc.version(), cdata.get('SIZEOF_VOID_P') * 8,
-  )
+	'PostgreSQL @0@ on @1@-@2@, compiled by @3@-@4@, @5@-bit'.format(
+		pg_version, host_machine.cpu_family(), host_system,
+		cc.get_id(), cc.version(), cdata.get('SIZEOF_VOID_P') * 8,
+	)
 )
 
 
@@ -3004,31 +3042,31 @@ nlsopt = get_option('nls')
 libintl = not_found_dep
 
 if not nlsopt.disabled()
-  # otherwise there'd be lots of
-  # "Gettext not found, all translation (po) targets will be ignored."
-  # warnings if not found.
-  msgfmt = find_program('msgfmt', required: nlsopt, native: true)
+	# otherwise there'd be lots of
+	# "Gettext not found, all translation (po) targets will be ignored."
+	# warnings if not found.
+	msgfmt = find_program('msgfmt', required: nlsopt, native: true)
 
-  # meson 0.59 has this wrapped in dependency('intl')
-  if (msgfmt.found() and
-      cc.check_header('libintl.h', required: nlsopt,
-        args: test_c_args, include_directories: postgres_inc))
+	# meson 0.59 has this wrapped in dependency('intl')
+	if (msgfmt.found() and
+			cc.check_header('libintl.h', required: nlsopt,
+				args: test_c_args, include_directories: postgres_inc))
 
-    # in libc
-    if cc.has_function('ngettext')
-      libintl = declare_dependency()
-    else
-      libintl = cc.find_library('intl',
-        has_headers: ['libintl.h'], required: nlsopt,
-        header_include_directories: postgres_inc,
-        dirs: test_lib_d)
-    endif
-  endif
+		# in libc
+		if cc.has_function('ngettext')
+			libintl = declare_dependency()
+		else
+			libintl = cc.find_library('intl',
+				has_headers: ['libintl.h'], required: nlsopt,
+				header_include_directories: postgres_inc,
+				dirs: test_lib_d)
+		endif
+	endif
 
-  if libintl.found()
-    i18n = import('i18n')
-    cdata.set('ENABLE_NLS', 1)
-  endif
+	if libintl.found()
+		i18n = import('i18n')
+		cdata.set('ENABLE_NLS', 1)
+	endif
 endif
 
 
@@ -3077,72 +3115,72 @@ mod_install_rpaths = []
 # libraries are needed, absolute LC_ID_DYLIB ensures libraries can be found in
 # their final destination.
 if host_system != 'darwin'
-  # Add absolute path to libdir to rpath. This ensures installed binaries /
-  # libraries find our libraries (mainly libpq).
-  bin_install_rpaths += dir_prefix / dir_lib
-  lib_install_rpaths += dir_prefix / dir_lib
-  mod_install_rpaths += dir_prefix / dir_lib
+	# Add absolute path to libdir to rpath. This ensures installed binaries /
+	# libraries find our libraries (mainly libpq).
+	bin_install_rpaths += dir_prefix / dir_lib
+	lib_install_rpaths += dir_prefix / dir_lib
+	mod_install_rpaths += dir_prefix / dir_lib
 
-  # Add extra_lib_dirs to rpath. This ensures we find libraries we depend on.
-  #
-  # Not needed on darwin even if we use relative rpaths for our own libraries,
-  # as the install_name of libraries in extra_lib_dirs will point to their
-  # location anyway.
-  bin_install_rpaths += postgres_lib_d
-  lib_install_rpaths += postgres_lib_d
-  mod_install_rpaths += postgres_lib_d
+	# Add extra_lib_dirs to rpath. This ensures we find libraries we depend on.
+	#
+	# Not needed on darwin even if we use relative rpaths for our own libraries,
+	# as the install_name of libraries in extra_lib_dirs will point to their
+	# location anyway.
+	bin_install_rpaths += postgres_lib_d
+	lib_install_rpaths += postgres_lib_d
+	mod_install_rpaths += postgres_lib_d
 endif
 
 
 # Define arguments for default targets
 
 default_target_args = {
-  'implicit_include_directories': false,
-  'install': true,
+	'implicit_include_directories': false,
+	'install': true,
 }
 
 default_lib_args = default_target_args + {
-  'name_prefix': '',
+	'name_prefix': '',
 }
 
 internal_lib_args = default_lib_args + {
-  'build_by_default': false,
-  'install': false,
+	'build_by_default': false,
+	'install': false,
 }
 
 default_mod_args = default_lib_args + {
-  'name_prefix': '',
-  'install_dir': dir_lib_pkg,
+	'name_prefix': '',
+	'install_dir': dir_lib_pkg,
 }
 
 default_bin_args = default_target_args + {
-  'install_dir': dir_bin,
+	'install_dir': dir_bin,
 }
 
 if get_option('rpath')
-  default_lib_args += {
-    'install_rpath': ':'.join(lib_install_rpaths),
-  }
+	default_lib_args += {
+		'install_rpath': ':'.join(lib_install_rpaths),
+	}
 
-  default_mod_args += {
-    'install_rpath': ':'.join(mod_install_rpaths),
-  }
+	default_mod_args += {
+		'install_rpath': ':'.join(mod_install_rpaths),
+	}
 
-  default_bin_args += {
-    'install_rpath': ':'.join(bin_install_rpaths),
-  }
+	default_bin_args += {
+		'install_rpath': ':'.join(bin_install_rpaths),
+	}
 endif
 
 
 # Helper for exporting a limited number of symbols
 gen_export_kwargs = {
-  'input': 'exports.txt',
-  'output': '@BASENAME@.'+export_file_suffix,
-  'command': [perl, files('src/tools/gen_export.pl'),
-   '--format', export_file_format,
-   '--input', '@INPUT0@', '--output', '@OUTPUT0@'],
-  'build_by_default': false,
-  'install': false,
+	'input': 'exports.txt',
+	'output': '@BASENAME@.'+export_file_suffix,
+	'command': [perl, files('src/tools/gen_export.pl'),
+	 '--format', export_file_format,
+	 '--input', '@INPUT0@', '--output', '@OUTPUT0@'],
+	'build_by_default': false,
+	'install': false,
 }
 
 # command to create stamp files on all OSs
@@ -3157,9 +3195,9 @@ catalog_pm = files('src/backend/catalog/Catalog.pm')
 perfect_hash_pm = files('src/tools/PerfectHash.pm')
 gen_kwlist_deps = [perfect_hash_pm]
 gen_kwlist_cmd = [
-  perl, '-I', '@SOURCE_ROOT@/src/tools',
-  files('src/tools/gen_keywordlist.pl'),
-  '--output', '@OUTDIR@', '@INPUT@']
+	perl, '-I', '@SOURCE_ROOT@/src/tools',
+	files('src/tools/gen_keywordlist.pl'),
+	'--output', '@OUTDIR@', '@INPUT@']
 
 
 
@@ -3168,56 +3206,56 @@ gen_kwlist_cmd = [
 ###
 
 if host_system == 'windows'
-  pg_ico = meson.project_source_root() / 'src' / 'port' / 'win32.ico'
-  win32ver_rc = files('src/port/win32ver.rc')
-  rcgen = find_program('src/tools/rcgen', native: true)
-
-  rcgen_base_args = [
-    '--srcdir', '@SOURCE_DIR@',
-    '--builddir', meson.project_build_root(),
-    '--rcout', '@OUTPUT0@',
-    '--out', '@OUTPUT1@',
-    '--input', '@INPUT@',
-    '@EXTRA_ARGS@',
-  ]
-
-  if cc.get_argument_syntax() == 'msvc'
-    rc = find_program('rc', required: true)
-    rcgen_base_args += ['--rc', rc.full_path()]
-    rcgen_outputs = ['@BASENAME@.rc', '@BASENAME@.res']
-  else
-    windres = find_program('windres', required: true)
-    rcgen_base_args += ['--windres', windres.full_path()]
-    rcgen_outputs = ['@BASENAME@.rc', '@BASENAME@.obj']
-  endif
-
-  # msbuild backend doesn't support this atm
-  if meson.backend() == 'ninja'
-    rcgen_base_args += ['--depfile', '@DEPFILE@']
-  endif
-
-  rcgen_bin_args = rcgen_base_args + [
-    '--VFT_TYPE', 'VFT_APP',
-    '--FILEENDING', 'exe',
-    '--ICO', pg_ico
-  ]
-
-  rcgen_lib_args = rcgen_base_args + [
-    '--VFT_TYPE', 'VFT_DLL',
-    '--FILEENDING', 'dll',
-  ]
-
-  rc_bin_gen = generator(rcgen,
-    depfile: '@BASENAME@.d',
-    arguments: rcgen_bin_args,
-    output: rcgen_outputs,
-  )
-
-  rc_lib_gen = generator(rcgen,
-    depfile: '@BASENAME@.d',
-    arguments: rcgen_lib_args,
-    output: rcgen_outputs,
-  )
+	pg_ico = meson.project_source_root() / 'src' / 'port' / 'win32.ico'
+	win32ver_rc = files('src/port/win32ver.rc')
+	rcgen = find_program('src/tools/rcgen', native: true)
+
+	rcgen_base_args = [
+		'--srcdir', '@SOURCE_DIR@',
+		'--builddir', meson.project_build_root(),
+		'--rcout', '@OUTPUT0@',
+		'--out', '@OUTPUT1@',
+		'--input', '@INPUT@',
+		'@EXTRA_ARGS@',
+	]
+
+	if cc.get_argument_syntax() == 'msvc'
+		rc = find_program('rc', required: true)
+		rcgen_base_args += ['--rc', rc.full_path()]
+		rcgen_outputs = ['@BASENAME@.rc', '@BASENAME@.res']
+	else
+		windres = find_program('windres', required: true)
+		rcgen_base_args += ['--windres', windres.full_path()]
+		rcgen_outputs = ['@BASENAME@.rc', '@BASENAME@.obj']
+	endif
+
+	# msbuild backend doesn't support this atm
+	if meson.backend() == 'ninja'
+		rcgen_base_args += ['--depfile', '@DEPFILE@']
+	endif
+
+	rcgen_bin_args = rcgen_base_args + [
+		'--VFT_TYPE', 'VFT_APP',
+		'--FILEENDING', 'exe',
+		'--ICO', pg_ico
+	]
+
+	rcgen_lib_args = rcgen_base_args + [
+		'--VFT_TYPE', 'VFT_DLL',
+		'--FILEENDING', 'dll',
+	]
+
+	rc_bin_gen = generator(rcgen,
+		depfile: '@BASENAME@.d',
+		arguments: rcgen_bin_args,
+		output: rcgen_outputs,
+	)
+
+	rc_lib_gen = generator(rcgen,
+		depfile: '@BASENAME@.d',
+		arguments: rcgen_lib_args,
+		output: rcgen_outputs,
+	)
 endif
 
 
@@ -3247,80 +3285,80 @@ subdir('config')
 # Then through src/port and src/common, as most other things depend on them
 
 frontend_port_code = declare_dependency(
-  compile_args: ['-DFRONTEND'],
-  include_directories: [postgres_inc],
-  dependencies: os_deps,
+	compile_args: ['-DFRONTEND'],
+	include_directories: [postgres_inc],
+	dependencies: os_deps,
 )
 
 backend_port_code = declare_dependency(
-  compile_args: ['-DBUILDING_DLL'],
-  include_directories: [postgres_inc],
-  sources: [errcodes], # errcodes.h is needed due to use of ereport
-  dependencies: os_deps,
+	compile_args: ['-DBUILDING_DLL'],
+	include_directories: [postgres_inc],
+	sources: [errcodes], # errcodes.h is needed due to use of ereport
+	dependencies: os_deps,
 )
 
 subdir('src/port')
 
 frontend_common_code = declare_dependency(
-  compile_args: ['-DFRONTEND'],
-  include_directories: [postgres_inc],
-  sources: generated_headers_stamp,
-  dependencies: [os_deps, zlib, zstd, lz4],
+	compile_args: ['-DFRONTEND'],
+	include_directories: [postgres_inc],
+	sources: generated_headers_stamp,
+	dependencies: [os_deps, zlib, zstd, lz4],
 )
 
 backend_common_code = declare_dependency(
-  compile_args: ['-DBUILDING_DLL'],
-  include_directories: [postgres_inc],
-  sources: generated_headers_stamp,
-  dependencies: [os_deps, zlib, zstd],
+	compile_args: ['-DBUILDING_DLL'],
+	include_directories: [postgres_inc],
+	sources: generated_headers_stamp,
+	dependencies: [os_deps, zlib, zstd],
 )
 
 subdir('src/common')
 
 # all shared libraries should depend on shlib_code
 shlib_code = declare_dependency(
-  link_args: ldflags_sl,
+	link_args: ldflags_sl,
 )
 
 # all static libraries not part of the backend should depend on this
 frontend_stlib_code = declare_dependency(
-  include_directories: [postgres_inc],
-  link_with: [common_static, pgport_static],
-  sources: generated_headers_stamp,
-  dependencies: [os_deps, libintl],
+	include_directories: [postgres_inc],
+	link_with: [common_static, pgport_static],
+	sources: generated_headers_stamp,
+	dependencies: [os_deps, libintl],
 )
 
 # all shared libraries not part of the backend should depend on this
 frontend_shlib_code = declare_dependency(
-  include_directories: [postgres_inc],
-  link_with: [common_shlib, pgport_shlib],
-  sources: generated_headers_stamp,
-  dependencies: [shlib_code, os_deps, libintl],
+	include_directories: [postgres_inc],
+	link_with: [common_shlib, pgport_shlib],
+	sources: generated_headers_stamp,
+	dependencies: [shlib_code, os_deps, libintl],
 )
 
 # For frontend code that doesn't use fe_utils - this mainly exists for libpq's
 # tests, which are defined before fe_utils is defined, as fe_utils depends on
 # libpq.
 frontend_no_fe_utils_code = declare_dependency(
-  include_directories: [postgres_inc],
-  link_with: [common_static, pgport_static],
-  sources: generated_headers_stamp,
-  dependencies: [os_deps, libintl],
+	include_directories: [postgres_inc],
+	link_with: [common_static, pgport_static],
+	sources: generated_headers_stamp,
+	dependencies: [os_deps, libintl],
 )
 
 # Dependencies both for static and shared libpq
 libpq_deps += [
-  thread_dep,
+	thread_dep,
 
-  gssapi,
-  ldap_r,
-  libintl,
-  ssl,
+	gssapi,
+	ldap_r,
+	libintl,
+	ssl,
 ]
 
 libpq_oauth_deps += [
-  thread_dep,
-  libcurl,
+	thread_dep,
+	libcurl,
 ]
 
 subdir('src/interfaces/libpq')
@@ -3330,40 +3368,40 @@ subdir('src/interfaces/libpq-oauth')
 
 # for frontend binaries
 frontend_code = declare_dependency(
-  include_directories: [postgres_inc],
-  link_with: [fe_utils, common_static, pgport_static],
-  sources: generated_headers_stamp,
-  dependencies: [os_deps, libintl],
+	include_directories: [postgres_inc],
+	link_with: [fe_utils, common_static, pgport_static],
+	sources: generated_headers_stamp,
+	dependencies: [os_deps, libintl],
 )
 
 backend_both_deps += [
-  thread_dep,
-  bsd_auth,
-  gssapi,
-  icu,
-  icu_i18n,
-  ldap,
-  libintl,
-  libnuma,
-  liburing,
-  libxml,
-  lz4,
-  pam,
-  ssl,
-  systemd,
-  zlib,
-  zstd,
+	thread_dep,
+	bsd_auth,
+	gssapi,
+	icu,
+	icu_i18n,
+	ldap,
+	libintl,
+	libnuma,
+	liburing,
+	libxml,
+	lz4,
+	pam,
+	ssl,
+	systemd,
+	zlib,
+	zstd,
 ]
 
 backend_mod_deps = backend_both_deps + os_deps
 
 backend_code = declare_dependency(
-  compile_args: ['-DBUILDING_DLL'],
-  include_directories: [postgres_inc],
-  link_args: ldflags_be,
-  link_with: [],
-  sources: generated_backend_headers_stamp,
-  dependencies: os_deps + backend_both_deps + backend_deps,
+	compile_args: ['-DBUILDING_DLL'],
+	include_directories: [postgres_inc],
+	link_args: ldflags_be,
+	link_with: [],
+	sources: generated_backend_headers_stamp,
+	dependencies: os_deps + backend_both_deps + backend_deps,
 )
 
 # install these files only during test, not main install
@@ -3410,44 +3448,44 @@ potentially_conflicting_files = []
 
 # convert all sources of potentially conflicting files into uniform shape
 foreach t : potentially_conflicting_files_t
-  potentially_conflicting_files += t.full_path()
+	potentially_conflicting_files += t.full_path()
 endforeach
 foreach t1 : configure_files
-  if meson.version().version_compare('>=0.59')
-    t = fs.parent(t1) / fs.name(t1)
-  else
-    t = '@0@'.format(t1)
-  endif
-  potentially_conflicting_files += meson.current_build_dir() / t
+	if meson.version().version_compare('>=0.59')
+		t = fs.parent(t1) / fs.name(t1)
+	else
+		t = '@0@'.format(t1)
+	endif
+	potentially_conflicting_files += meson.current_build_dir() / t
 endforeach
 foreach sub, fnames : generated_sources_ac
-  sub = meson.project_build_root() / sub
-  foreach fname : fnames
-    potentially_conflicting_files += sub / fname
-  endforeach
+	sub = meson.project_build_root() / sub
+	foreach fname : fnames
+		potentially_conflicting_files += sub / fname
+	endforeach
 endforeach
 
 # find and report conflicting files
 foreach build_path : potentially_conflicting_files
-  build_path = host_system == 'windows' ? fs.as_posix(build_path) : build_path
-  # str.replace is in 0.56
-  src_path = meson.current_source_dir() / build_path.split(meson.current_build_dir() / '')[1]
-  if fs.exists(src_path) or fs.is_symlink(src_path)
-    conflicting_files += src_path
-  endif
+	build_path = host_system == 'windows' ? fs.as_posix(build_path) : build_path
+	# str.replace is in 0.56
+	src_path = meson.current_source_dir() / build_path.split(meson.current_build_dir() / '')[1]
+	if fs.exists(src_path) or fs.is_symlink(src_path)
+		conflicting_files += src_path
+	endif
 endforeach
 # XXX: Perhaps we should generate a file that would clean these up? The list
 # can be long.
 if conflicting_files.length() > 0
-  errmsg_cleanup = '''
+	errmsg_cleanup = '''
 Conflicting files in source directory:
-  @0@
+	@0@
 
 The conflicting files need to be removed, either by removing the files listed
 above, or by running configure and then make maintainer-clean.
 '''
-  errmsg_cleanup = errmsg_cleanup.format(' '.join(conflicting_files))
-  error(errmsg_nonclean_base.format(errmsg_cleanup))
+	errmsg_cleanup = errmsg_cleanup.format(' '.join(conflicting_files))
+	error(errmsg_nonclean_base.format(errmsg_cleanup))
 endif
 
 
